# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without    jdk6

%define section   free
%define base_name jaxme

Name:           ws-%{base_name}
Version:        0.5.1
Release:	10%{?dist}
Epoch:          0
Summary:        Open source implementation of JAXB

Group:          Development/Libraries/Java
License:        ASL 2.0
URL:            http://ws.apache.org/jaxme/
Source0:        ws-jaxme-%{version}-src.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

Patch0:         ws-jaxme-docs_xml.patch
Patch1:         ws-jaxme-catalog.patch
Patch2:         ws-jaxme-system-dtd.patch
Patch3:         ws-jaxme-jdk16.patch

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.5.32
Requires:       jaxb_2_1_api
Requires:       stax_1_0_api
Requires:       xerces-j2
Requires:       xml-commons-jaxp-1.3-apis
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-apache-resolver
BuildRequires:  ant-trax
BuildRequires:  antlr
BuildRequires:  docbook-style-xsl
BuildRequires:  jaxb_2_1_api
BuildRequires:  junit >= 0:3.8.1
BuildRequires:  hsqldb
BuildRequires:  log4j
BuildRequires:  stax_1_0_api
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xmldb-api
BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRequires:  xml-commons-resolver12

%description
A Java/XML binding compiler takes as input a schema 
description (in most cases an XML schema, but it may 
be a DTD, a RelaxNG schema, a Java class inspected 
via reflection, or a database schema). The output is 
a set of Java classes:
* A Java bean class matching the schema description. 
  (If the schema was obtained via Java reflection, 
  the original Java bean class.)
* Read a conforming XML document and convert it into 
  the equivalent Java bean.
* Vice versa, marshal the Java bean back into the 
  original XML document.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -n %{name}
%patch0 -p0
%patch1 -p0
%patch2 -p1
DOCBOOKX_DTD=`%{_bindir}/xmlcatalog %{_datadir}/sgml/docbook/xmlcatalog "-//OASIS//DTD DocBook XML V4.1.2//EN" 2>/dev/null`
%{__perl} -pi -e 's|@DOCBOOKX_DTD@|$DOCBOOKX_DTD|' src/documentation/manual/jaxme2.xml
%if %with jdk6
%patch3 -p1
%endif
find . -name "*.jar" | xargs rm

%build
export OPT_JAR_LIST="xalan-j2 ant/ant-trax xalan-j2-serializer xml-commons-resolver12 ant/ant-apache-resolver"
export CLASSPATH=$(build-classpath antlr hsqldb jaxb_2_1_api junit log4j stax_1_0_api xmldb-api xerces-j2 xml-commons-jaxp-1.3-apis)
ant all Docs.all \
-Dbuild.sysclasspath=first \
-Ddocbook.home=%{_datadir}/sgml/docbook \
-Ddocbookxsl.home=%{_datadir}/sgml/docbook/xsl-stylesheets

%install
rm -rf $RPM_BUILD_ROOT

install -dm 755 $RPM_BUILD_ROOT%{_javadir}/%{base_name}
for jar in dist/*.jar; do
   jbs=`basename ${jar}`
   jnm=`echo ${jbs} | sed -e 's|\.jar||'`
   install -Dpm 644 ${jar} \
     $RPM_BUILD_ROOT%{_javadir}/%{base_name}/ws-${jnm}.jar
done
(cd $RPM_BUILD_ROOT%{_javadir}/%{base_name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{base_name} && for jar in ws-*.jar; do ln -sf ${jar} `echo $jar| sed  "s|ws-||g"`; done)

# javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/docs/src/documentation/content/apidocs $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr build/docs/src/documentation/content/manual $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(0644,root,root,0755)
%doc LICENSE prerequisites/README
%{_javadir}/%{base_name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Mon Dec 08 2008 Will Tatam <will.tatam@red61.com> 0.5.1-10
- Auto rebuild for JPackage 5 in mock

* Fri Sep 19 2008 David Walluck <dwalluck@redhat.com> 0:0.5.1-9
- (Build)Requires: stax_1_0_api
- add jaxb_2_1_api to CLASSPATH

* Thu Sep 18 2008 David Walluck <dwalluck@redhat.com> 0:0.5.1-8
- rebuild

* Fri Aug 15 2008 David Walluck <dwalluck@redhat.com> 0:0.5.1-7
- add patch for offline xml

* Mon Jul 07 2008 David Walluck <dwalluck@redhat.com> 0:0.5.1-6
- add patch for JDK6

* Mon Jul 07 2008 David Walluck <dwalluck@redhat.com> 0:0.5.1-5
- fix BuildRoot

* Mon Jul 07 2008 David Walluck <dwalluck@redhat.com> 0:0.5.1-4
- add %%{?dist} to release tag
- remove javadoc scriptlets
- fix %%doc
- fix file permissions

* Wed Mar 05 2008 Fernando Nasser <fnasser@redhat.com> - 0:0.5.1-3jpp
  From Ralph Apel <r.apel at r-apel.de>:
- Add xalan-j2-serializer to build-classpath
- BuildRequire docbook-style-xsl

* Tue May 16 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:0.5.1-2jpp.ep1.1
- First build for EAP product
- Use new naming convention

* Fri May 19 2006 Fernando Nasser <fnasser@redhat.com> - 0:0.5.1-2jpp_1rh
- Merge with upstream for upgrade

* Fri May 19 2006 Fernando Nasser <fnasser@redhat.com> - 0:0.5.1-2jpp
- Add missing header

* Fri May 19 2006 Deepak Bhole <dbhole@redhat.com> - 0:0.5.1-1jpp
- Upgrade to 0.5.1

* Mon Apr 25 2005 Fernando Nasser <fnasser.redhat.com> - 0:0.3.1-1jpp_1rh
- First Red Hat build
- Changes to use locally installed DTDs

* Thu Sep 09 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.3.1-1jpp
- Fix version in changelog
- Upgrade to 0.3.1

* Fri Aug 30 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0-0.b1.4jpp
- Build with ant-1.6.2

* Fri Aug 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0-0.b1.3jpp
- Void change

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:2.0-0.b1.2jpp
- Upgrade to Ant 1.6.X

* Fri Mar 04 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0-0.b1.1jpp
- First JPackage release
